#pragma once
#include <ConsumerImplHelper/Platform.h>

namespace GenTLConsumerImplHelper
{
    class BufferAllocator
    {
    public:
        virtual void* AllocateBuffer( size_t size_by ) = 0;
        virtual void FreeBuffer( void* pBuffer ) = 0;

        virtual void Delete() = 0;
        
        virtual ~BufferAllocator() {};
    };


    class HeapAllocator : public BufferAllocator
    {
    public:
        virtual void* AllocateBuffer(size_t size_by ) { return new char[size_by]; } 
        virtual void FreeBuffer( void* pBuffer ) { delete[] static_cast<char*>(pBuffer); }
        virtual void Delete() { delete this; }
    };

}
